package xyz.lychee.lagfixer.libs.adventure.text.flattener;

import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.function.Function;
import xyz.lychee.lagfixer.libs.adventure.builder.AbstractBuilder;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.adventure.util.Buildable;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface ComponentFlattener extends Buildable<ComponentFlattener, Builder> {
   @NotNull
   static @NotNull Builder builder() {
      return new ComponentFlattenerImpl.BuilderImpl();
   }

   static @NotNull ComponentFlattener basic() {
      return ComponentFlattenerImpl.BASIC;
   }

   static @NotNull ComponentFlattener textOnly() {
      return ComponentFlattenerImpl.TEXT_ONLY;
   }

   void flatten(final @NotNull Component input, final @NotNull FlattenerListener listener);

   public interface Builder extends AbstractBuilder<ComponentFlattener>, Buildable.Builder<ComponentFlattener> {
      @NotNull
      <T extends Component> @NotNull Builder mapper(final @NotNull Class<T> type, final @NotNull Function<T, String> converter);

      @NotNull
      <T extends Component> @NotNull Builder complexMapper(final @NotNull Class<T> type, final @NotNull BiConsumer<T, Consumer<Component>> converter);

      @NotNull
      @NotNull Builder unknownMapper(final @Nullable Function<Component, String> converter);
   }
}
